import { ADD_PRODUCT_TO_CART, REMOVE_PRODUCT_FROM_CART } from './actions';

const initialState = {
  products: [
    { id: 'p1', title: 'Gaming monitor', price: 5490 },
    { id: 'p2', title: 'Gaming laptop', price: 19990 },
    { id: 'p3', title: 'Electric scooter', price: 14990 },
    { id: 'p4', title: 'Gaming mouse', price: 990 },
    { id: 'p5', title: 'Gaming keyboard', price: 1290 },
    { id: 'p6', title: 'Headphones', price: 2990 },
    { id: 'p7', title: '2T oil', price: 490 },
    { id: 'p8', title: 'Gaming chair', price: 20990 }
  ],
  cart: []
};

const shopReducer = (state = initialState, action) => {
  let updatedCart;
  let updatedItemIndex;
  switch (action.type) {
    case ADD_PRODUCT_TO_CART:
      updatedCart = [...state.cart];
      updatedItemIndex = updatedCart.findIndex(
        item => item.id === action.payload.id
      );
      if (updatedItemIndex < 0) {
        updatedCart.push({ ...action.payload, quantity: 1 });
      } else {
        const updatedItem = {
          ...updatedCart[updatedItemIndex]
        };
        updatedItem.quantity++;
        updatedCart[updatedItemIndex] = updatedItem;
      }
      return { ...state, cart: updatedCart };
    case REMOVE_PRODUCT_FROM_CART:
      updatedCart = [...state.cart];
      updatedItemIndex = updatedCart.findIndex(
        item => item.id === action.payload
      );
      const updatedItem = {
        ...updatedCart[updatedItemIndex]
      };
      updatedItem.quantity--;
      if (updatedItem.quantity <= 0) {
        updatedCart.splice(updatedItemIndex, 1);
      } else {
        updatedCart[updatedItemIndex] = updatedItem;
      }
      return { ...state, cart: updatedCart };
    default:
      return state;
  }
};

export default shopReducer;